#include "pam_ru.h"

/* Necessary for become to work properly with pam_ru */
struct ruauthdata {
  char *ph_path;
  char *ru_agent;
};

int pam_sm_authenticate(pamh, flags, argc, argv)
	pam_handle_t 	*pamh;
	int 	flags;
	int 	argc;
	const char 	**argv;
{

/* 

   This module should never be used alone, so I put all the returns
   as cred insufficient.

*/
   int ret;
   int become = 0;
   char *user;
   char *password;
   struct ruauthdata *ad;
   char bbuffer[512];
   char *buser;
   char *bpoint;

   unsigned long time_mul = 15000000;
   int debdev = 0;
   int errno;
	
   int i;
   for (i = 0; i < argc; i++) {
      if (!strcmp("debug", argv[i])) debdev = 1;
   }

/* Get the user */
   if (pam_get_item(pamh, PAM_USER, (void *)&user) != PAM_SUCCESS) {
      debout("ru_store - user not set");
      return PAM_AUTH_ERR;
   } 


/* Get the password to be stored */
   if (pam_get_item(pamh, PAM_OLDAUTHTOK, (void *)&password) != PAM_SUCCESS) {
      debout("ru_store - error retrieving old authtok.");
      return PAM_AUTH_ERR;
   }
 

   if (password) {
      if (!strncmp(password, "save ", 5)) {
         if (debdev) debout("ru_store - Password to store: %s", password);
         if (strstr(password, ":")) become = 1;
         ret = ru_save(user, password, pamh, 1, debdev, time_mul);
      }
      else {
         if (debdev) debout("ru_store - second time through for the service.");
         return PAM_SUCCESS;
      }
   }
   else {
      if (debdev) debout("ru_store - no password set.");
      return PAM_SUCCESS;
   }


/* Necessary for become accounts to work properly with pam_ru */
   if (password) {
      if (become) {
         strncpy(bbuffer, password, sizeof(bbuffer)-1);
         bbuffer[sizeof(bbuffer)-1] = '\0';
         bpoint = strchr(bbuffer, ' ');
         *bpoint = '\0';
         buser = bpoint + 1;
         bpoint = strchr(buser, ':');
         *bpoint = '\0';
         if (pam_get_data(pamh, "ru_auth", (const void **)&ad) == PAM_SUCCESS) {
            ad->ru_agent = strdup(buser);
            if (!ad->ru_agent) {
               //cheaplog("malformed ruauthdata struct.  Seek help.");
               return PAM_AUTH_ERR;
            }
         }
      }
   }


   password = NULL;
   if (pam_set_item(pamh, PAM_OLDAUTHTOK, (void *)&password) != PAM_SUCCESS)
      return PAM_SERVICE_ERR;

   return PAM_SUCCESS;
}

int pam_sm_setcred(pamh, flags, argc, argv)
	pam_handle_t 	*pamh;
	int 	flags;
	int 	argc;
	const char 	**argv;
{
   return PAM_SUCCESS;
}
